import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

class Ventana extends JFrame
{
	private JButton neg,cur,nuevo,abrir,guardar,cortar,copiar,pegar;      //Bortones de la Barra de Herramientas
	private JComboBox ComboFuente, ComboLetra, ComboColor;       //Combo Box con distintas opciones
	private String fuente="Arial";          //Fuente actual
	private int tamao=12;               //Tamao de fuente actual
	private JScrollPane scroll;              //Contenedor del rea de Texto
	private Font Fuente;                //Almacena caractersticas de la Fuente
	private JTextArea areaTexto;            //Donde se escribe
	private boolean principal;           //Ventana principal tiene caractersticas distintivas
	
	public Ventana(boolean a)             //Constructor de la Clase Ventana
	{
		super("Editor de Texto Avanzado");              //Ttulo de la Ventana
		principal=a;
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");    //"Apariencia y Sensacin"  Windows
		}catch (Exception e) {	};
		
		Fuente= new Font(fuente, Font.PLAIN, tamao);    //Establece caractersticas iniciales de la Fuente
		areaTexto= new JTextArea();
		areaTexto.setFont(Fuente);               //Establece la fuente del rea de Texto
		areaTexto.setLineWrap(true);
		
		scroll= new JScrollPane(areaTexto);              //Agrega el rea de Texto al Contenedor ScrollPane
		getContentPane().add(scroll,BorderLayout.CENTER);              //Lo ubica al centro
		BarraDeMenus();                             //Funcin que crea y aade la Barra de Mens a la ventana
		BarraDeHerramientas();                    //Funcin que crea y aade la Barra de Herramientas a la ventana
		if(principal)
			setDefaultCloseOperation(EXIT_ON_CLOSE);       //El botn "X" hace un System.exit()
		setSize(800,560);                 //Establece tamao
		setVisible(true);
	}
	
	public void BarraDeMenus()           
	{
		JMenuBar BarraDeMenus = new JMenuBar();
		
		JMenu MenuArchivo = new JMenu("Archivo");
		
		JMenuItem ItemNuevo= new JMenuItem("Nuevo");
		ItemNuevo.addActionListener          //Aade el Escucha de Eventos
			(
			new ActionListener ()            
		{
			public void actionPerformed (ActionEvent e) 
			{ Nuevo();}
		}
		);
		
		JMenuItem ItemAbrir= new JMenuItem("Abrir");
		ItemAbrir.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Abrir();}
		}
		);
		
		JMenuItem ItemGuardar= new JMenuItem("Guardar...");
		ItemGuardar.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Guardar();}
		}
		);
		
		JMenuItem ItemSalir;
		if (principal)
			ItemSalir= new JMenuItem("Salir");
		else
			ItemSalir= new JMenuItem("Cerrar Ventana");
		
		ItemSalir.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{
				int opcin = JOptionPane.showConfirmDialog(null,"Desea guardar los cambios antes de salir?",null,JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
				if(opcin == JOptionPane.YES_OPTION) //Desea Guardar
				{
					Guardar();
					if (principal)
						System.exit(0);         //Si se cierra la ventana principal, se cierra el programa
					else
						setVisible(false);     //Caso contrario...
				}
				else
					if(opcin == JOptionPane.NO_OPTION)   //No desea guardar
					{
						if (principal)
							System.exit(0);
						else
							setVisible(false);
					}
				}
		}
		);
		
		JMenu MenuEditar = new JMenu("Editar");
		
		JMenuItem ItemCopiar= new JMenuItem("Copiar");
		ItemCopiar.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Copiar();}
		}
		);
		
		JMenuItem ItemCortar= new JMenuItem("Cortar");
		ItemCortar.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Cortar();}
		}
		);
		
		JMenuItem ItemPegar= new JMenuItem("Pegar");
		ItemPegar.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Pegar();}
		}
		);
		
		JMenuItem ItemFuente= new JMenuItem("Fuente...");
		ItemFuente.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Fuente();}
		}
		);
		
		JMenuItem ItemSelTodo= new JMenuItem("Seleccionar Todo");
		ItemSelTodo.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ SelTodo();}
		}
		);
		
		JMenu MenuAyuda = new JMenu("Ayuda");
		JMenuItem ItemAyuda= new JMenuItem("Ayuda");
		ItemAyuda.addActionListener
			(
			new ActionListener ()
		{
			public void actionPerformed (ActionEvent e)
			{ Ayuda();}
		}
		);
		
		MenuArchivo.add(ItemNuevo);
		MenuArchivo.add(ItemAbrir);
		MenuArchivo.addSeparator();
		MenuArchivo.add(ItemGuardar);
		MenuArchivo.add(ItemSalir);
		MenuEditar.add(ItemCopiar);
		MenuEditar.add(ItemCortar);
		MenuEditar.add(ItemPegar);
		MenuEditar.addSeparator();
		MenuEditar.add(ItemSelTodo);
		MenuEditar.addSeparator();
		MenuEditar.add(ItemFuente);
		
		MenuAyuda.add(ItemAyuda);
		
		BarraDeMenus.add(MenuArchivo);
		BarraDeMenus.add(MenuEditar);
		BarraDeMenus.add(MenuAyuda);
		
		setJMenuBar(BarraDeMenus);
	}
	
	public void BarraDeHerramientas()
	{
		JToolBar BarraDeHerramientas = new JToolBar();
		
		nuevo = new JButton();
		nuevo.setIcon(new ImageIcon("imgenes/nuevo.gif"));
		nuevo.setMargin(new Insets(0,0,0,0));
		nuevo.setToolTipText("Nuevo archivo");
		nuevo.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Nuevo();
			}
		}
		);
		
		BarraDeHerramientas.add(nuevo);
		
		abrir = new JButton();
		abrir.setIcon(new ImageIcon("imgenes/abrir.gif"));
		abrir.setMargin(new Insets(0,0,0,0));
		abrir.setToolTipText("Abrir archivo");
		abrir.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Abrir();
			}
		}
		);
		BarraDeHerramientas.add(abrir);
		
		guardar = new JButton();
		guardar.setIcon(new ImageIcon("imgenes/guardar.gif"));
		guardar.setMargin(new Insets(0,0,0,0));
		guardar.setToolTipText("Guardar...");
		guardar.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Guardar();
			}
		}
		);
		BarraDeHerramientas.add(guardar);
		BarraDeHerramientas.addSeparator();
		
		neg = new JButton();
		neg.setIcon(new ImageIcon("imgenes/neg.gif"));
		neg.setMargin(new Insets(0,0,0,0));
		neg.setToolTipText("Negrita");
		neg.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				if (Fuente.isPlain() || Fuente.isItalic())
					Fuente = new Font(fuente, Font.BOLD, tamao);
				else
					Fuente = new Font(fuente, Font.PLAIN, tamao);
				areaTexto.setFont(Fuente);
			}
		}
		);
		BarraDeHerramientas.add(neg);
		
		cur	= new JButton();
		cur.setIcon(new ImageIcon("imgenes/cur.gif"));
		cur.setMargin(new Insets(0,0,0,0));
		cur.setToolTipText("Cursiva");
		cur.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				if (Fuente.isPlain() || Fuente.isBold())
					Fuente = new Font(fuente, Font.ITALIC, tamao);
				else
					Fuente = new Font(fuente, Font.PLAIN, tamao);
				areaTexto.setFont(Fuente);
			}
		}
		);
		BarraDeHerramientas.add(cur);
		BarraDeHerramientas.addSeparator();
		
		cortar = new JButton();
		cortar.setIcon(new ImageIcon("imgenes/cortar.gif"));
		cortar.setMargin(new Insets(0,0,0,0));
		cortar.setToolTipText("Cortar");
		cortar.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Cortar();
			}
		}
		);
		
		BarraDeHerramientas.add(cortar);
		
		copiar = new JButton();
		copiar.setIcon(new ImageIcon("imgenes/copiar.gif"));
		copiar.setMargin(new Insets(0,0,0,0));
		copiar.setToolTipText("Copiar");
		copiar.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Copiar();
			}
		}
		);
		
		BarraDeHerramientas.add(copiar);
		
		pegar = new JButton();
		pegar.setIcon(new ImageIcon("imgenes/pegar.gif"));
		pegar.setMargin(new Insets(0,0,0,0));
		pegar.setToolTipText("Pegar");
		pegar.addActionListener
			(
			new ActionListener()
		{
			public void actionPerformed (ActionEvent e)
			{
				Pegar();
			}
		}
		);
		BarraDeHerramientas.add(pegar);
		BarraDeHerramientas.addSeparator();
		
		ComboFuente=new JComboBox();
		ComboFuente.addItem("Tamao de fuente...");
		ComboFuente.addItem("10");
		ComboFuente.addItem("12");
		ComboFuente.addItem("14");
		ComboFuente.addItem("18");
		ComboFuente.addItem("20");
		ComboFuente.addItem("26");
		ComboFuente.setToolTipText("Seleccione el tamao de fuente deseado");
		
		ComboFuente.addItemListener(
			new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				int opcin;
				
				opcin = ComboFuente.getSelectedIndex();
				
				switch(opcin)
				{
				case 1:
					Fuente = new Font(fuente, Font.PLAIN, 10);
					areaTexto.setFont(Fuente);
					tamao = 10;
					break;
				case 2:
					Fuente = new Font(fuente, Font.PLAIN, 12);
					areaTexto.setFont(Fuente);
					tamao = 12;
					break;
				case 3:
					Fuente = new Font(fuente, Font.PLAIN, 14);
					areaTexto.setFont(Fuente);
					tamao = 14;
					break;
				case 4:
					Fuente = new Font(fuente, Font.PLAIN, 18);
					areaTexto.setFont(Fuente);
					tamao = 18;
					break;
				case 5:
					Fuente = new Font(fuente, Font.PLAIN, 20);
					areaTexto.setFont(Fuente);
					tamao = 20;
					break;
				case 6:
					Fuente = new Font(fuente, Font.PLAIN, 26);
					areaTexto.setFont(Fuente);
					tamao = 26;
					break;
				}
			}
		}
		);
		
		BarraDeHerramientas.add(ComboFuente);
		
		ComboLetra=new JComboBox();
		ComboLetra.addItem("Fuente...");
		ComboLetra.addItem("Arial");
		ComboLetra.addItem("Verdana");
		ComboLetra.addItem("Tahoma");
		ComboLetra.addItem("Courier New");
		ComboLetra.addItem("Ringbearer");
		ComboLetra.addItem("Times New Roman");
		ComboFuente.setToolTipText("Seleccione la fuente deseada");
		
		ComboLetra.addItemListener(
			new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				int opcin;
				
				opcin = ComboLetra.getSelectedIndex();
				
				switch(opcin)
				{
				case 1:
					Fuente = new Font("Arial", Font.PLAIN, tamao);
					areaTexto.setFont(Fuente);
					fuente="Arial";
					break;
				case 2:
					Fuente = new Font("Verdana", Font.PLAIN, tamao);
					areaTexto.setFont(Fuente);
					fuente="Verdana";
					break;
				case 3:
					Fuente = new Font("Tahoma", Font.PLAIN, tamao);
					areaTexto.setFont(Fuente);
					fuente="Tahoma";
					break;
				case 4:
					Fuente = new Font("Courier New", Font.PLAIN, tamao);
					areaTexto.setFont(Fuente);
					fuente="Courier New";
					break;
				case 5:
					Fuente = new Font("Ringbearer", Font.PLAIN,tamao);
					areaTexto.setFont(Fuente);
					fuente="Ringbearer";
					break;
				case 6:
					Fuente = new Font("Times New Roman", Font.PLAIN, tamao);
					areaTexto.setFont(Fuente);
					fuente="Times New Roman";
					break;
				}
			}
		}
		);
		
		BarraDeHerramientas.add(ComboLetra);
		ComboColor = new JComboBox();
		ComboColor.addItem("Color de fuente...");
		ComboColor.addItem("Azul");
		ComboColor.addItem("Rojo");
		ComboColor.addItem("Amarillo");
		ComboColor.addItem("Automatico");
		ComboColor.addItem("Naranja");
		ComboColor.addItem("Verde");
		ComboFuente.setToolTipText("Seleccione el color de la fuente");
		
		ComboColor.addItemListener(
			new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				int opcin = ComboColor.getSelectedIndex();
				switch(opcin)
				{
				case 1:
					
					areaTexto.setForeground(Color.blue);
					break;
				case 2:
					areaTexto.setForeground(Color.red);
					break;
				case 3:
					areaTexto.setForeground(Color.yellow);
					break;
				case 4:
					areaTexto.setForeground(Color.black);
					break;
				case 5:
					areaTexto.setForeground(Color.orange);
					break;
				case 6:
					areaTexto.setForeground(Color.green);
					break;
				}
			}
		}
		);
		
		BarraDeHerramientas.add(ComboColor);
		
		getContentPane().add(BarraDeHerramientas,BorderLayout.NORTH);  //Agrega la Barra de Herramientas a la ventana, al NORTE
	}
	
	public void Nuevo()
	{
		new Ventana(false);
	}
	
	public void Abrir()
	{
		JFileChooser Selector = new JFileChooser();
		Selector.showOpenDialog(this);        //Muestra el Dilogo de Seleccin de Archivo
		File nombre= Selector.getSelectedFile();      // nombre representa en forma abstracta la ruta del archivo seleccionado
		if(nombre.exists() && nombre.isFile())
		{
			try
			{
				BufferedReader Entrada= new BufferedReader(new FileReader (nombre));    //BufferedReader lee de un Stream de entrada de caracteres, colocndolos en un Buffer
				StringBuffer buffer= new StringBuffer();                 //StringBuffer de Entrada de caracteres - til porque permite modificaciones *1
				String TextoTemp;                                       //String para dar formato con retorno de lneas
				//areaTexto.setText("");                //Borra lo que se encuentre en pantalla
				while ((TextoTemp=Entrada.readLine()) !=null)      //Lee lneas del Stream de Entrada
					buffer.append(TextoTemp+ "\n");         //Agrega un retorno de lnea    *1
				areaTexto.setText(buffer.toString());          //Coloca el texto en el rea de Texto, convirtindolo a String
				Entrada.close();         //Cierra el Stream
				this.setTitle("Editor de Texto Avanzado - "+nombre.getName());  //Agrega el Nombre del archivo a la Barra de Ttulos
			}
			catch (IOException e)
			{
				JOptionPane.showMessageDialog(null,"Error al abrir el Archivo. Intente ms tarde","Error al Abrir",JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
	public void Guardar()
	{
		JFileChooser Elector = new JFileChooser();          
		Elector.showSaveDialog(this);            //Dilogo de Guardar
		File nombre2= Elector.getSelectedFile();     //Toma la seleccin del usuario
		try
		{
			PrintWriter Salida= new PrintWriter(new FileWriter(nombre2),true);     //Imprime a un Stream de salida de texto
			Salida.write(areaTexto.getText());    //Escribe un String - Autoflushing automtico
			Salida.close();                                     //Cierra el Stream
			this.setTitle("Editor de Texto Avanzado - "+nombre2.getName());    //Agrega el Nuevo nombre del archivo a la Barra de Ttulos
		}
		catch(IOException ioException)
		{
			JOptionPane.showMessageDialog(null,"Ha habido un error en el proceso. Intente nuevamente ms tarde","Error al Guardar",JOptionPane.ERROR_MESSAGE);
		};
	}
	
	public void SelTodo()
	{
		areaTexto.selectAll();
	}
	
	public void Copiar()
	{
		areaTexto.copy();
	}
	
	public void Cortar()
	{
		areaTexto.cut();
	}
	
	public void Pegar()
	{
		areaTexto.paste();
	}
	
	public void Fuente()
	{
		tamao = Integer.parseInt(JOptionPane.showInputDialog("Ingrese nuevo tamao de Fuente"));     //Toma tamao deseado de fuente
		Fuente = new Font(fuente, Font.PLAIN, tamao);
		areaTexto.setFont(Fuente);
	}
	
	public void Ayuda()
	{
		JOptionPane.showMessageDialog(null,"Ninguna por ahora");
	}
}

class Splash extends JWindow implements Runnable     //Ventana de Splash
{
	private JLabel ImagenSplash;
	
	public Splash()
	{
		ImagenSplash= new JLabel(new ImageIcon("imgenes/splash.jpg"));      //Crea un Contenedor JLabel para ubicar la imagen deseada
		getContentPane().add(ImagenSplash,BorderLayout.CENTER);
		pack();
		Dimension Tamao = Toolkit.getDefaultToolkit().getScreenSize();      //Encapsula el tamao de la pantalla
		Dimension TamaoDelLabel = ImagenSplash.getPreferredSize();      //Encapsula el tamao del label
		setLocation(Tamao.width/2 - (TamaoDelLabel.width/2),Tamao.height/2 - (TamaoDelLabel.height/2));      //Ubica la Ventana Splash al centro de la pantalla
		setVisible(true);
	}
	
	public void run()	
	{	
	}
}

public class Editor        //Clase que incluye el mtodo main()
{
	public static void main(String args[])
	{
		Splash splash = new Splash();      //Instancia la clase Splash
		Thread nuevo = new Thread(splash);     //Llama al constructor de la clase Thread y le pasa el objeto recin creado al constructor
		nuevo.start();
		try
		{
			nuevo.sleep(5000);                                 //Duerme el Hilo cinco segundos
		}catch(InterruptedException e) { };
		
		nuevo.interrupt();                     //Al despertar, lo para
		splash.setVisible(false);          //Oculta la ventana de Splash
		new Ventana(true);          //Crea una Ventana (Principal)
	}
}
